Zen API

- Home
- Topics
- Types
- Files

All Classes Files Functions Variables Typedefs Friends Macros Modules Pages
Public Member Functions | Related
kQueue Class Reference
kApi/Data

## Description

Represents a FIFO queue implemented with a dynamic array.

The kQueue class represents a dynamic, array-based queue of objects or values. The kQueue constructor accepts a kType value that determines the type of items that will be stored in the queue. The queue will automatically grow as new items are added.

kStatus QueueExample()
{
kQueue queue = kNULL;
k32s values[] = { 1, 2, 3, 5, 7, 9 };
kSize i;
kTry
{
//create a queue that can store 32-bit integers
kTest(kQueue_Construct(&queue, kTypeOf(k32s), 0, kNULL));
//add some initial items to the queue
for (i = 0; i < kCountOf(values); ++i)
{
kTest(kQueue_Add(queue, &values[i]);
}
//print some information about the queue and its items
printf("Item type: %s\n", kType_Name(kQueue_ItemType(queue)));
printf("Count: %u\n", (k32u) kQueue_Count(queue));
for (i = 0; i < kQueue_Count(queue); ++i)
{
//the kQueue_As_ macro can be used to get a queue item and cast it to the desired type;
//this is equivalent to *(k32s*)kQueue_At(queue, i);
k32s value = kQueue_As_(queue, i, k32s);
printf("Item %u: %d\n", (k32u)i, value);
}
}
kFinally
{
kObject_Destroy(queue);
kEndFinally();
}
return kOK;
}

For queues that contain objects (e.g. kImage) as opposed to values (e.g. k32s), the objects are not automatically destroyed when the queue is destroyed. To recursively destroy both the queue and the queue items, use kObject_Dispose.

kQueue supports the kObject_Clone, kObject_Dispose, and kObject_Size methods.

kQueue supports the kdat5 and kdat6 serialization protocols.

Inheritance diagram for kQueue:

## Public Member Functions
kStatus | kQueue_Add (kQueue queue, const void *item)
| Adds the specified item to the end of the queue. More...
kStatus | kQueue_AddCount (kQueue queue, kSize count)
| Increases the queue count by the specified amount. More...
kStatus | kQueue_Allocate (kQueue queue, kType itemType, kSize initialCapacity)
| Reallocates the queue item buffer. More...
kStatus | kQueue_Assign (kQueue queue, kQueue source)
| Performs a shallow copy of the source queue. More...
void * | kQueue_At (kQueue queue, kSize index)
| Returns a pointer to the specified item in the queue buffer. More...
kSize | kQueue_Capacity (kQueue queue)
| Returns the number of elements for which space has been allocated. More...
kStatus | kQueue_Clear (kQueue queue)
| Sets the count of queue items to zero. More...
kStatus | kQueue_Construct (kQueue *queue, kType itemType, kSize initialCapacity, kAlloc allocator)
| Constructs a kQueue object. More...
kSize | kQueue_Count (kQueue queue)
| Returns the current count of items in the queue. More...
void * | kQueue_DataAt (kQueue queue, kSize index)
| Calculates an element address. More...
kStatus | kQueue_Item (kQueue queue, kSize index, void *item)
| Gets the value of an item. More...
kSize | kQueue_ItemSize (kQueue queue)
| Returns the queue element size. More...
kType | kQueue_ItemType (kQueue queue)
| Returns the queue element type. More...
kStatus | kQueue_Purge (kQueue queue)
| Disposes any elements in the queue and sets the count of queue items to zero. More...
kStatus | kQueue_Remove (kQueue queue, void *item)
| Removes the item at the head of the queue. More...
kStatus | kQueue_RemoveCount (kQueue queue, kSize count)
| Decreases the queue count by the specified amount. More...
kStatus | kQueue_Reserve (kQueue queue, kSize capacity)
| Ensures that capacity is reserved for at least the specified number of queue items. More...
kStatus | kQueue_SetItem (kQueue queue, kSize index, const void *item)
| Sets the value of an item. More...
Public Member Functions inherited from kObject
kAlloc | kObject_Alloc (kObject object)
| Gets the memory allocator associated with this object. More...
kStatus | kObject_Clone (kObject *object, kObject source, kAlloc allocator)
| Constructs a new object by copying an existing object, including any aggregated child elements. More...
kStatus | kObject_Destroy (kObject object)
| Destroys the object. More...
kStatus | kObject_Dispose (kObject object)
| Destroys the object and any aggregated child elements. More...
kBool | kObject_Equals (kObject object, kObject other)
| Determines whether the object is equal to another object. More...
kBool | kObject_HasForeignData (kObject object)
| Reports whether the object, including aggregated child elements, contains any foreign memory references. More...
kSize | kObject_HashCode (kObject object)
| Gets a hash code representing the state of this object. More...
kBool | kObject_Is (kObject object, kType type)
| Determines whether this object is an instance of the specified type. More...
kBool | kObject_IsShared (kObject object)
| Reports whether the object is currently shared (reference count greater than one). More...
kStatus | kObject_SetPool (kObject object, kObjectPool pool)
| Sets the object pool associated with this object. More...
kStatus | kObject_Share (kObject object)
| Increments the reference count associated with this object. More...
kSize | kObject_Size (kObject object)
| Estimates the memory consumed by this object, including any aggregated child elements. More...
kType | kObject_Type (kObject object)
| Returns the type of the object. More...
Public Member Functions inherited from kCollection
kSize | kCollection_Count (kCollection collection)
| Gets the collection element count. More...
kIterator | kCollection_GetIterator (kCollection collection)
| Returns an iterator to the first element in the collection. More...
kBool | kCollection_HasNext (kCollection collection, kIterator iterator)
| Determines whether a collection has another item. More...
kType | kCollection_ItemType (kCollection collection)
| Gets the collection element type. More...
void * | kCollection_Next (kCollection collection, kIterator *iterator)
| Gets a pointer to the next collection element and then advances the iterator. More...

## Related
#define | kQueue_AddT(kQueue_queue, TPtr_item)
| Adds the specified item to the end of the queue. More...
#define | kQueue_AsT(kQueue_queue, kSize_index, T)
| Gets the value of an item. More...
#define | kQueue_AtT(kQueue_queue, kSize_index, T)
| Returns a strongly-typed pointer to the specified item in the queue buffer. More...
#define | kQueue_DataAtT(kQueue_queue, kSize_index, T)
| Calculates an element address. More...
#define | kQueue_ItemT(kQueue_queue, kSize_index, TPtr_item)
| Gets the value of an item. More...
#define | kQueue_SetAsT(kQueue_queue, kSize_index, T_value, T)
| Sets the value of an item. More...
#define | kQueue_SetItemT(kQueue_queue, kSize_index, TPtr_item)
| Sets the value of an item. More...
Related inherited from kCollection
#define | kCollection_NextT(kCollection_collection, kIteratorPtr_iterator, T)
| Gets a strongly-typd pointer to next collection element and then advances the iterator. More...

## Additional Inherited Members
Protected Member Functions inherited from kObject
kStatus | kObject_FreeMem (kObject object, void *mem)
| Protected method called by derived classes to free memory using the object's allocator. More...
kStatus | kObject_FreeMemRef (kObject object, void *mem)
| Protected method called by derived classes to free memory (and reset the provided memory pointer to kNULL) using the object's allocator. More...
kStatus | kObject_GetMem (kObject object, kSize size, void *mem)
| Protected method called by derived classes to allocate memory using the object's allocator. More...
kStatus | kObject_GetMemZero (kObject object, kSize size, void *mem)
| Protected method called by derived classes to allocate and zero memory using the object's allocator. More...
kStatus | kObject_Init (kObject object, kType type, kAlloc alloc)
| Protected method called by derived classes to initialize the kObject base class. More...
kStatus | kObject_VDisposeItems (kObject object)
| Protected virtual method that destroys any aggregated child objects associated with a collection. More...
kBool | kObject_VEquals (kObject object, kObject other)
| Protected virtual method that compares two objects for equality. More...
kBool | kObject_VHasForeignData (kObject object)
| Protected virtual method that reports whether the object, including aggregated child elements, contains any foreign memory references. More...
kSize | kObject_VHashCode (kObject object)
| Protected virtual method that calculates a hash code representing the object instance. More...
kStatus | kObject_VInitClone (kObject object, kObject source, kAlloc allocator)
| Protected virtual method that clones (makes a deep copy of) the specified source object. More...
kStatus | kObject_VRelease (kObject object)
| Protected virtual method that deallocates any resources owned by the object. More...
kSize | kObject_VSize (kObject object)
| Protected virtual method that calculates the total size (in bytes) of the object instance. More...

The documentation for this class was generated from the following file:

- Data/kQueue.h